/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.datei;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.datei.boundary.AbstractDateiImportSearchParameters;
import de.ivu.elect.business.datei.boundary.DateiImportChangeEvent;
import de.ivu.elect.business.datei.boundary.DateiImportConversationStore;
import de.ivu.elect.business.datei.boundary.DateiImportExtendedDAO;
import de.ivu.elect.business.datei.boundary.DateiImportSearch;
import de.ivu.elect.business.datei.boundary.DateiImportSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.datei.entity.DateiImport;
import de.ivu.elect.business.datei.entity.DateiImportMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDateiImportSearchView.COMPONENT_NAME)
@View(viewId = AbstractDateiImportSearchView.VIEW_ID, useCase = UseCasePermission.DATEI_IMPORT_SEARCH)
public abstract class AbstractDateiImportSearchView extends AbstractElectSearchView<DateiImport> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dateiImportSearchView";
  
  public static final String VIEW_ID = "/datei/datei-import-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDateiImportSearchView requestHandler;

  @Inject
  private transient DateiImportExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DateiImportConversationStore.class)
  protected transient DateiImportConversationStore conversationStore;

  @Inject
  protected transient DateiImportSearch search;

  @Inject
  @ConversationGroup(AbstractDateiImportSearchParameters.class)
  protected transient DateiImportSearchParameters searchParameters;

  @Inject
  protected transient DateiImportMeta entityMeta;

  public AbstractDateiImportSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DateiImport getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DateiImport entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DateiImportSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DateiImport> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DateiImport> create();
  }

  @Override
  public List<DateiImport> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DateiImport> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDateiImportChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DateiImportChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDateiImportSearchView {

    @View
    @Inject
    private transient Instance<AbstractDateiImportSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDateiImportSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
